#===============================================================
# V Make Configuration file - Version 1.20 - 6/30/98
#
# For Windows95/NT mingw32
# Note: mingw32 requires the use of mingw32 and
# unix tools ported to WIN, such as cp, rm, and touch.
#
# Copyright (C) 1995,1996,1997,1998  Bruce E. Wampler
#
# This file is part of the V C++ GUI Framework, and is covered
# under the terms of the GNU Library General Public License,
# Version 2. This library has NO WARRANTY. See the source file
# vapp.cxx for more complete information about license terms.
#===============================================================


#---------------------------------------------------------------------
# Version info
#---------------------------------------------------------------------
VV	=	1.20
VVW	=	120


#---------------------------------------------------------------------
# HOMEV info
# change this to the directory you've installed V to
#---------------------------------------------------------------------
HOMEV	=	C:/v
HOMEMW	=	C:/mingw32


#---------------------------------------------------------------------
# Tools used in the makefile execution
#---------------------------------------------------------------------
CC	=	gcc
CXX	=	g++
GMAKE	=	gmake
AR	=	ar
RANLIB	=	ranlib

#---------------------------------------------------------------------
# VPATH for dependencies on header files
#---------------------------------------------------------------------
VPATH=$(HOMEV)/includew/v


#---------------------------------------------------------------------
# Select the architecture of your system.
#---------------------------------------------------------------------

ARCH = mingw32

Arch = $(ARCH)

USE_3D = yes

#---------------------------------------------------------------------
# Select Debug or no Debug
#---------------------------------------------------------------------
#DEBUG	=	yes
DEBUG	= no

#---------------------------------------------------------------------
# Select Develop or not - used for original development
#---------------------------------------------------------------------
#DEVEL	=	yes
DEVEL	= no

#---------------------------------------------------------------------
# Define filename extensions that are targeted by cleanup's
#---------------------------------------------------------------------
CLEANEXTS= *.bak *.tmp


#---------------------------------------------------------------------
# Architecture dependent directory locations
#---------------------------------------------------------------------
VLibDir	=	$(HOMEV)/lib/$(Arch)
oDir	=	$(HOMEV)/obj/$(Arch)
LibDir	=	$(HOMEV)/lib/$(Arch)
Bin	=	$(HOMEV)/bin/$(Arch)

#---------------------------------------------------------------------
# Architecture independent 
#---------------------------------------------------------------------
INCDIR	=	-I$(HOMEV)/includew
LIBDIR	=	-L$(LibDir)
LIBNAME	=	libV
V1NAME 	=	v1
LIBS	=	-lV -lcomctl32 -mwindows
#
# This is an alternative specification that will cause a DOS
# window to come up
#
#LIBS	=	-lV -lcomdlg32 -luser32 -lgdi32 -lcomctl32



#---------------------------------------------------------------------
# C/C++ compile options
#---------------------------------------------------------------------
CFLAGS	+= $(INCDIR) 
ifeq ($(DEBUG),no)
CFLAGS	+=	-O2 -D_WIN32
endif
ifeq ($(DEBUG),yes)
CFLAGS	+=	-g -D_WIN32
endif
ifeq ($(DEVEL),yes)
CFLAGS	+=	-DDEVEL
endif

#---------------------------------------------------------------------
# LINK/LOAD options
#---------------------------------------------------------------------
LDFLAGS	=	$(LIBDIR) $(LIBS)
